
template <int N>
void swap(int(&perm)[N], int idx1, int idx2) {
	if (idx1 < N && idx2 < N && idx1 != idx2) {
		int tmp = perm[idx1];
		perm[idx1] = perm[idx2];
		perm[idx2] = tmp;
	}
}

template <int N>
bool next_perm(int idx_start, int idx_end, int(&perm2)[N]) {
	int i = idx_end - 1;
while (i >= idx_start && perm2[i] > perm2[i + 1])
i--;

int k = 1;
while (i + k < idx_end - k + 1) {
	swap(perm2, i + k, idx_end + 1 - k);
	k++;
}

if (i >= idx_start) {
	for (int k = i + 1; (k < N) && (k <= idx_end); k++) {
		if (perm2[i] < perm2[k]) {
			swap(perm2, i, k);
			return true;
		}
	}
}

return false;
}

