#pragma once

template <int N>
bool get_next_variation(int value_min, int value_max,  int (&variation)[N]) {
	int idx = N - 1;

	while (variation[idx] + 1 > value_max)
		idx--;

	if (idx >=0) {
		variation[idx]++;
		for (int k = idx +1; k < N; k++)
			variation[k] = value_min;

		return true;
	}
	else
		return false;
}

template <int N>
bool get_next_variation(int value_min, int value_max, int min_idx, int max_idx, int (&variation)[N]) {
	int idx = max_idx;

	while (variation[idx] + 1 > value_max)
		idx--;

	if (idx >=min_idx) {
		variation[idx]++;
		for (int k = idx + 1; k <= max_idx; k++)
			variation[k] = value_min;

		return true;
	}
	else
		return false;
}

template <int N, int K>
bool get_next_variation(int (&value_min)[K], int (&value_max)[K], int min_idx, int max_idx, int (&variation)[N]) {
	int idx = max_idx;

	while (variation[idx] + 1 > value_max[idx - min_idx])
		idx--;

	if (idx >=min_idx) {
		variation[idx]++;
		for (int k = idx +1; k <= max_idx; k++)
			variation[k] = value_min[k - min_idx];

		return true;
	}
	else
		return false;
}

template <int N>
bool get_next_variation(int (&value_min)[N], int (&value_max)[N],  int (&variation)[N]) {
	int idx = N - 1;

	while (variation[idx] + 1 > value_max[idx])
		idx--;

	if (idx >=0) {
		variation[idx]++;
		for (int k = idx +1; k < N; k++)
			variation[k] = value_min[idx];

		return true;
	}
	else
		return false;
}


template <int N>
bool get_next_variation(int (&value_min)[N], int (&value_max)[N],  int min_idx, int max_idx, int (&variation)[N]) {
	int idx = max_idx;

	while (variation[idx] + 1 > value_max[idx])
		idx--;

	if (idx >=min_idx) {
		variation[idx]++;
		for (int k = idx +1; k <= max_idx; k++)
			variation[k] = value_min[k];

		return true;
	}
	else
		return false;
}

